/***************************************************************************
 *   Copyright (C) 2009 by Lassi Väätämöinen   *
 *   lassi.vaatamoinen@ixonos.com   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef SEARCHPLUGIN_H
#define SEARCHPLUGIN_H


#include <QObject>

#include "PluginInterface.h"

class QWidget;
class QComboBox;
class QPushButton;
class QLineEdit;

namespace qtrapids
{

class SearchPlugin : public PluginInterface
{
	Q_OBJECT
	Q_INTERFACES(qtrapids::PluginInterface)

public:
	SearchPlugin();
	virtual void initialize(PluginHostInterface* host);
	virtual QWidget* getGui();

signals:
	void searchResult(QWidget* resultwidget);

private slots:
	void on_searchButton_clicked();
	void on_searchResult(QWidget* resultWidget);

private:
	QComboBox *comboBox_;
	QLineEdit *searchLine_;
	QPushButton *searchButton_;
	PluginHostInterface* host_;

};

} // namespace qtrapids

#endif